/*
masscalc.c: The top file of masscalc, the executable that actually
runs the calculation. 
Part of XMolCalc-1.0 by Martin Doll, Ph.D.; 1999.
modified by Peter A. Cejchan to command line interface
Mon Jul  8 13:44:27 EDT 2002
<pac@next.gli.cas.cz>

*/


#include <stdio.h>
#include <sys/types.h>	/* Needed for creat() */
#include <sys/stat.h>	/* ditto */
#include <fcntl.h>		/* ditto */
#include "mproc.c"

int MAXLENGTH = 102;


float M_compound; 	 /* Masses assigned */
char *lenght_ptr;
int count=0;


int main()	
{
	FILE *in_file;	  /* File containing the input data */
	FILE *out_file;	
	
	in_file = stdin;
	out_file = stdout;	
	
	while (line_input!="q"){
		fgets(line_input, sizeof(line_input), in_file);
 		if ((*line_input == '\n') || (*line_input == '\0')) {
			M_ideal = 0;
			exit (-1);
		}

		lenght_ptr=&line_input[0];     	/* check the lenght of the input line */

		while (*lenght_ptr != '\0')     {
		++count;
		++lenght_ptr;
		}
        
		if (count >= MAXLENGTH ) {
		fprintf(out_file, "Input too long");
		M_compound = 0;
		count = 0;
		}
		else {	
		M_compound = process_mass(line_input);
	
		/* Round to only 2 digits */
		fprintf(out_file, "%.2f\n", M_compound);   
		fflush(out_file);
		}
	}	

	/* Reset masses */
        M_compound=M_ideal = 0; 
	return(0);
}
