/*
mfunct.c - Contains all the funcion prototypes used in 
mproc.c and masscalc.c to build the executalble masscalc. 
1999 - Part of XMolCalc-1.0 by Martin K-H. Doll, Ph.D.
*/


#include <stdlib.h>		/* Needed by the wstrtol/atoi     */
#include <limits.h>		/* ditto		          */
#include <string.h>		/* Needed by strlen		  */
#include <ctype.h>              /* Needed by isalpha              */
#include "elements.h"

char *start_ptr;		/* Pointer stays at first char of */
				/* the input string 		  */

char *string_ptr;		/* Pointer to the el of Cl in the */
				/* input string (as example)	  */

char *rest_ptr;			/* Needed by strtol		  */

char line_input[100];		/* Input line keyboard 	          */



/* For the one char elements remaining in the string	 	  */

char rest_line[100];

char *ptr;

char new_line[100];

char *new_ptr;



/* Atomic indices of the elements that remained in the rest	  */
/* string at the end.						  */


int atomic_index;

int value;			/* Needed in clean_string         */

float M_ideal = 0;	        /* The molecular mass.            */
                                /* Calcuation will add increments */
				/* for each element and its index */
FILE *out_file;






/*
Declaration of the clean_string function. This one checks at the very
start of the string processing if there are totally wrong characters
or typos contained like '#' etc. - Results in an error message.
*/

char *clean_string_funct(char *string_ptr)

{

        while (*string_ptr != '\0')  {          
                             

        if (*string_ptr == ('~')  || *string_ptr == ('!') || \
            *string_ptr == ('@')  || *string_ptr == ('#') || \
            *string_ptr == ('$')  || *string_ptr == ('%') || \
            *string_ptr == ('^')  || *string_ptr == ('&') || \
            *string_ptr == ('*')  || *string_ptr == ('`') || \
            *string_ptr == ('-')  || *string_ptr == ('_') || \
            *string_ptr == ('+')  || *string_ptr == ('=') || \
            *string_ptr == ('?')  || *string_ptr == ('/') || \
            *string_ptr == ('<')  || *string_ptr == (',') || \
            *string_ptr == ('>')  || *string_ptr == ('.') || \
            *string_ptr == (':')  || *string_ptr == (';') || \
            *string_ptr == ('\"') || *string_ptr == ('{') || \
            *string_ptr == ('}')  || *string_ptr == ('[') || \
	    *string_ptr == (']')  || *string_ptr == ('|') || \
	    *string_ptr == ('\'') || *string_ptr == ('\\')|| \
            *string_ptr == (')')  || *string_ptr == ('(')
	   )
                        
                {
                        out_file = fopen("mass.tmp", "w"); 
			fprintf(out_file, "Bad character");
        		fclose(out_file);
						
			*line_input = '0';                                    
            		exit (0);
                }
        
        else
             		++string_ptr;
             		continue;
        }

return (line_input);

}





/*
Declaration of function_1 that  scans the string for two char
element entries, calculates their mass fragment and removes
it from the string. Here only Sn for tin and not sn is allowed;
case sensitive but no index required. Though Sn1 is counted
(index allowed). SN entries run through and would be counted
in the 1_char function as S1N1. However, "sn" results in error,
N1S1 runs trough of course.
*/

char *my_string_search_funct_1(char *string_ptr, char find, char neighbor_1,\
				char neighbor_2, float atom_mass_100)  	

{	
	start_ptr = &line_input[0];	/* Go to beginning of	  */
					/* the input line and stay*/
								

while (*string_ptr != '\0') 	{	


	while (*string_ptr != find)
	
	
	{	/* If end of string is	  */
		/* reached without finding*/
		
		if (*string_ptr == '\0')
		return (NULL);		
				
		++string_ptr;
	}
		
		
		if (*--string_ptr != neighbor_1)
		
		
		{  		if (*string_ptr == neighbor_2)
		
			{  	out_file = fopen("mass.tmp", "w"); 
				fprintf(out_file, "Case error");
        			fclose(out_file);
				exit (0);
			}
			
			
			else
		
			++string_ptr;
			++string_ptr;
			
			continue;	/* Back to the while loop */
		
		}
		
		
		else
		
		*++string_ptr;
		*++string_ptr;		/* goes to atomic index   */
	


	        value = isupper(*string_ptr);

       		 if ((value != 0) || (*string_ptr == '\n')) {

		
			atomic_index = 1;
			
			M_ideal += (atom_mass_100 * atomic_index);
			
			/* Erase the small letter */
			
			*--string_ptr = '\0';
			
			/* Go one step right to	  */ 
			/* point to the rest 	  */
			
			++string_ptr;				      	
	
	
			/* Erase capital letter	  */
	
			start_ptr[strlen(start_ptr)-1] = '\0';
	
			strcat(start_ptr, string_ptr);	
			

			/* Needed to continue correctly when going */
			/* back to the loop		           */
			
			--string_ptr;
						 		      	    
			continue;
			
		 }
		



	else {
		

	value = islower(*string_ptr);

	if ((value != 0) || (*string_ptr == '\n')) {

			
	out_file = fopen("mass.tmp", "w"); 
	fprintf(out_file, "Case error");
       	fclose(out_file);
	*start_ptr = '0';		
	exit (0);
	}	




	
	else {
		
		
	atomic_index = strtol(&string_ptr[0], &rest_ptr, 10);
	

	if (atomic_index >= 10000) { 
        out_file = fopen("mass.tmp", "w"); 
 	fprintf(out_file, "Index too large");
       	fclose(out_file);
       	exit(0);
       	}


			M_ideal += (atom_mass_100 * atomic_index);
	
		
			*string_ptr = '\0';	/* Erase the atomic index */
	
			++string_ptr;		/* Go one step right to   */
						/* point to the rest 	  */
	
	
			start_ptr[strlen(start_ptr)-1] = '\0';
			start_ptr[strlen(start_ptr)-1] = '\0';
		
			strcat(start_ptr, rest_ptr);	
			string_ptr = &start_ptr[0];		
		
		  	 /* Without that doesn't see all entries  */
		  	 
			continue;	
		
		}
	}	
		
}
	
return (start_ptr);

}	






/*
Function_2: Checks the string for 2_char_element entries,
calculates their mass fragments as long as it finds an numeric
entry to the right of the second char in the symbol; then it 
removes the entry from the string. Both, Sn and sn are o.k. 
for tin, but if there is no index, there will be an error. 
Btw.: 'sN' will go through and has to be stopped in function_4.
*/


char *my_string_search_funct_2(char *string_ptr, char find, char neighbor_1,\
				 char neighbor_2, float atom_mass_100)	      	
{


while (*string_ptr != '\0')	{	
		

	start_ptr = line_input; /* Go to beginning of input line */
				/* and stay there		 */
	
	while ((*string_ptr != find) && (*string_ptr != '\0'))
	
	{
		++string_ptr;
	}
		
		
		if ((*--string_ptr != neighbor_1) && (*string_ptr != neighbor_2)) {
		
		++string_ptr;
		++string_ptr;
		continue;	/* Back to the while loop 	 */
		
		}
	
	
		else
		
		*++string_ptr;
		*++string_ptr;	/*goes to the atomic index 	 */
	


        value = isalpha(*string_ptr);

        if (value != 0) {

                out_file = fopen("mass.tmp", "w");
                fprintf(out_file, "Missing index");
                fclose(out_file);
                *start_ptr = '\0';
                M_ideal = 0;
                exit (0);

                }


	if ((*string_ptr == '\0') || (*string_ptr == '\n')){

		out_file = fopen("mass.tmp", "w");
                fprintf(out_file, "Missing index");
                fclose(out_file);
                *start_ptr = '\0';
                M_ideal = 0;
                exit (0);

                }



		
		else {
		
		atomic_index = strtol(&string_ptr[0], &rest_ptr, 10);
	
		   
		if (atomic_index >= 10000) {
                out_file = fopen("mass.tmp", "w");
                fprintf(out_file, "Index too large");
                fclose(out_file);
                exit(0);
                }


		M_ideal += (atom_mass_100 * atomic_index);
	
		
		*string_ptr = '\0';	/* Erase the atomic index	 */
	
		++string_ptr;		/* Go one step to the right to	 */
					/* point to the rest 		 */
	
	
	
		start_ptr[strlen(start_ptr)-1] = '\0';
		start_ptr[strlen(start_ptr)-1] = '\0';
	
	
		/* Without that doesn't see all entries	*/
		
		strcat(start_ptr, rest_ptr);	
		string_ptr = &start_ptr[0];				
		continue;	
	
		
		}

}
	
return (start_ptr);

}	






/*
This function_3 scans for intries like Cn,cN. No matter what case,
only one char element entries with indices are allowed. Error if 
no index.
*/


char *rest_string_evaluator_1(char *start_ptr)

{
	/* Start pointer cannot be '\n' and such things; function will */ 
	/* give an incorrect result with an input line like only "Sm". */


	strcpy(new_line, start_ptr);
	
	new_ptr=&new_line[0];
	

	while ((*new_ptr != '\0') && (*new_ptr != '\n'))	{
 	
	value = isalpha(*new_ptr);

		if (value != 0) {
	    
	  	++new_ptr;

	    	if ((*new_ptr == '\0') || (*new_ptr == '\n')){
	      	out_file = fopen("mass.tmp", "w"); 
		fprintf(out_file, "Missing index");
        	fclose(out_file);
	      	*start_ptr = '\0';
	      	M_ideal = 0;
	      	exit (0);
	    
		}
	    

	    	value = isalpha(*new_ptr);

	    	if (value != 0) {

	      	out_file = fopen("mass.tmp", "w"); 
		fprintf(out_file, "Missing index");
        	fclose(out_file);
	      	*start_ptr = '\0';
	      	M_ideal = 0;
	      	exit (0);
		
		}

	    
	else {
	      --new_ptr;
	     }

	    
	}  	



	++new_ptr;
	continue;
	


}	/* End of while */

return (start_ptr);

}		





/*
Definition of function_4 that evaluates the rest string left 
from function_1/2; the string contains only one char elements.
The mass fragments are calculated and added to M_ideal. For 
no index entries like SN results in a wrong number! But sn is 
complained as wrong case because of s in the switch - Error.
*/			     


float rest_string_evaluator_2(char *start_ptr)

{
	
	strcpy(rest_line, start_ptr);
	ptr=&rest_line[0];
	
	
	while ((*ptr != '\0') && (*ptr != '\n')) {
	
	
	switch (*ptr) {
		
		
       	case 'K':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (K * atomic_index);
		break;
		
	
	case 'C':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (C * atomic_index);
		break;
			
	
	case 'H':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (H * atomic_index);
		break;
			
	
	case 'N':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (N * atomic_index);
		break;
			
	
	case 'S':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (S * atomic_index);
		break;
			
	
	case 'O':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (O * atomic_index);
		break;
			
	
	case 'P':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (P * atomic_index);
		break;
			
	
	case 'B':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (B * atomic_index);
		break;
			
	
	case 'I':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (I * atomic_index);
		break;
			
	
	case 'W':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (W * atomic_index);
		break;
			
	
	case 'V':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (V * atomic_index);
		break;
			
	
	case 'F':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (F * atomic_index);
		break;
			
	
	case 'U':
       		++ptr;
       		sscanf(ptr, "%d", &atomic_index);
		M_ideal += (U * atomic_index);
		break;
			
	
	default:
		out_file = fopen("mass.tmp", "w"); 
		fprintf(out_file, "Input error");
        	fclose(out_file);
		M_ideal = 0;
		exit (0);
			
		
			}	/* End of switch */

			
	
	
	
	while ((*ptr != '\0') ||  (*ptr == '\n')) {
	
	value = isalpha(ptr[0]);
	
	if (value == 0) {
	++ptr;
	continue;
	}
	
	else 
	break;


	
	}			/* End of while of isalpha */
	
			
			
	if (atomic_index >= 10000) { 
			
	out_file = fopen("mass.tmp", "w"); 
	fprintf(out_file, "Index too large");
       	fclose(out_file);
	exit(0);

	}
			
	
	continue;	/* Go back to top of while */  			
	
			
} 	/* End of while that belongs to switch */
	

return (M_ideal);

}






/* Definition of function_5 that evaluates the rest string left from*/
/* function_1/2; the string contains only one char elements. The    */
/* mass fragments are calculated and added to the M_ideal value. For*/
/* no index entries like SN or sN or Sn results in a wrong number!  */
/* This is regulated by combination with another function, however. */
/* No cases are required, but indices.				    */


float rest_string_evaluator_3(char *start_ptr)

{

	strcpy(rest_line, start_ptr);
	ptr=&rest_line[0];
	

	while ((*ptr != '\0') && (*ptr != '\n')) {
	



        switch (*ptr) {


        case 'K':
        case 'k':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (K * atomic_index);
                break;


        case 'C':
        case 'c':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (C * atomic_index);
                break;


        case 'H':
        case 'h':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (H * atomic_index);
                break;


        case 'N':
        case 'n':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (N * atomic_index);
                break;


        case 'S':
        case 's':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (S * atomic_index);
                break;


        case 'O':
        case 'o':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (O * atomic_index);
                break;


        case 'P':
        case 'p':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (P * atomic_index);
                break;


        case 'B':
        case 'b':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (B * atomic_index);
                break;


        case 'I':
        case 'i':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (I * atomic_index);
                break;


        case 'W':
        case 'w':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (W * atomic_index);
                break;


        case 'V':
        case 'v':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (V * atomic_index);
                break;


        case 'F':
        case 'f':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (F * atomic_index);
                break;


        case 'U':
        case 'u':
                ++ptr;
                sscanf(ptr, "%d", &atomic_index);
                M_ideal += (U * atomic_index);
                break;


        default:
                out_file = fopen("mass.tmp", "w");
                fprintf(out_file, "Invalid element");
                fclose(out_file);
                M_ideal = 0;
                exit (0);



                }               /* End of switch */



		
	while ((*ptr != '\0') ||  (*ptr == '\n')) {
	
	value = isalpha(ptr[0]);
	
	if (value == 0) {
	++ptr;
	continue;
	}
	
	else 
	break;


	
	}		/* End of while of isalpha */


			
			
	if (atomic_index >= 10000) { 
			
	out_file = fopen("mass.tmp", "w"); 
	fprintf(out_file, "Index too large");
       	fclose(out_file);
	exit (0);
	}
			
			
	continue;	 /* Go back to top of while */  			
	
			
	} 		 /* End of while that belongs to switch */

	
return (M_ideal);

}






/*
Function_6: Checks for single_char elements without an index
and then counts these elements for 1 index and removes them    
from the string. Tin Sn would only be crunched written as SN.   
Then it would be equal to S1N1. Such a type from the user would
result in a wrong result because this input string would exist.
Keep in mind: This funct is used in a "correct case" environment.
Entries like N1P2 run through unchanged. 
*/


char *check_single_char_no_index(char *string_ptr, char find)

{

	start_ptr = line_input; 

	
	while (*string_ptr != '\0') {


	while (*string_ptr != find) {
	
		if (*string_ptr == '\0')
		return (NULL);			
		++string_ptr;
	}
		
	

	++string_ptr;
	value = isalpha(*string_ptr);



        if ((value != 0) || (*string_ptr == '\n')) {

			
	switch (find) {
		
		
		
	case 'K':
		M_ideal += (K * 1);		
		break;
		
	
	case 'C':
		M_ideal += (C * 1);
		break;
			
	
	case 'H':
		M_ideal += (H * 1);
		break;
			
		
	case 'N':
		M_ideal += (N * 1);
		break;
			
	
	case 'S':							
		M_ideal += (S * 1);
		break;
			
		
	case 'O':
		M_ideal += (O * 1);
		break;
			
		
	case 'P':
		M_ideal += (P * 1);
		break;		
			
		
	case 'B':
		M_ideal += (B * 1);
		break;
			

	case 'I':
		M_ideal += (I * 1);
		break;
		
	
	case 'W':
		M_ideal += (W * 1);
		break;
		
		
	case 'V':
		M_ideal += (V * 1);
		break;
		
		
	case 'F':
		M_ideal += (F * 1);
		break;
			
			
	case 'U':
		M_ideal += (U * 1);
		break;
			
			
	default:
		out_file = fopen("mass.tmp", "w"); 
		fprintf(out_file, "Input error");
        	fclose(out_file);
		exit (0);
			
		
	}	/* End of switch */
	
		


		 /* Go to single char el and erase */

		 *--string_ptr = '\0';	
				
			   
                 /* Go one step to the right to point to the rest */

		 ++string_ptr;	
				
		     
	
		 strcat(start_ptr, string_ptr);	
		 string_ptr = &start_ptr[0];
				
       	}		
	
		continue;
}


return (start_ptr);

}


